/*
Prancha Livre de Comunicao
Copyright (C) 2005 Percy Nohama <percy@ppgia.pucpr.br>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// Button2.cpp : implementation file
//

#include "stdafx.h"
#include "PranchaVirtual.h"
#include "Button2.h"
#include "PranchaVirtualDlg.h"
#include "PerfilDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CButton2

CButton2::CButton2()
{
	//***********************
	//*		Construtor		*
	//***********************

	// Inicializa as variveis
 	m_aberto    = FALSE;
	m_cima		= FALSE;
	m_movendo	= FALSE;
	m_corFundo	= GetSysColor(COLOR_BTNFACE);
}

CButton2::~CButton2()
{
	//***********************
	//*		Destrutor		*
	//***********************
	
}


BEGIN_MESSAGE_MAP(CButton2, CButton)
	//************************************************************
	//*	Associa o ID dos componentes grficos com a funo		 *
	//************************************************************

	//{{AFX_MSG_MAP(CButton2)
	ON_WM_TIMER()
	ON_WM_MOUSEMOVE()
	ON_MESSAGE(WM_MOUSELEAVE, OnMouseLeave)
	ON_MESSAGE(WM_MOUSEHOVER, OnMouseHover)
	ON_COMMAND(ID_NOVO, MenuInserir)
	ON_COMMAND(ID_APAGAR, MenuApagar)
	ON_COMMAND(ID_EDITAR, MenuEditar)
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CButton2 message handlers

void CButton2::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	//*******************
	//	Desenha o boto	*
	//*******************

// Faz o CDC do boto
	CDC *pDC = CDC::FromHandle( lpDrawItemStruct->hDC );
	
// Pega as medidas do boto
	CRect rect;
	GetClientRect( rect );
  
// Pega o estado do boto
    BOOL   bFoco         = lpDrawItemStruct->itemState & ODS_FOCUS;
    BOOL   bPressionado  = lpDrawItemStruct->itemState & ODS_SELECTED; 

// Medidas da Imagem
	CRect       rectImagem=rect;
	
// Se estiver Presionado move o boto
	if( bPressionado  )
		rectImagem.OffsetRect( 1 , 1 );
    
/// Medidas do Texto
	CRect       rectTexto=rectImagem;

// Diminui a imagem a tela
	rectImagem.top	  += 5;
	rectImagem.bottom -= 5;
	rectImagem.left   += 4;
	rectImagem.right  -= 4;

	rectTexto.bottom = rectImagem.bottom*1.95		;

// Ttulo da janela
	CString b;
	GetParent()->GetWindowText(b);
	b.Delete(1,b.GetLength()-1);

// Se legenda==true, diminui a imagem
	if(((CPranchaVirtualDlg*)GetParent())->config.legenda==true && b=="P")
		rectImagem.bottom-=10;
	else
		rectTexto.top    = 1000;

// Pega a Fonte do aplicativo
	CFont *font = GetParent()->GetFont();
        
// Desenha o fundo
//
   pDC->FillSolidRect( rect,m_corFundo );

// Desenha o contorno
	pDC->FrameRect(rect,CBrush::FromHandle((HBRUSH)GetStockObject(BLACK_BRUSH))); 
	
	
 	if(m_aberto) {
// Desenha uma IMAGEM VLIDA
		if(b=="P")((CPranchaVirtualDlg*)GetParent())->Imagem(pDC, m_arquivo,rectImagem);
		else ((CPranchaVirtualDlg*)((CPerfilDlg*)GetParent())->GetParent())->Imagem(pDC, m_arquivo,rectImagem);
		}
	else{
// Desenho da IMAGEM INVLIDA
		CRect rect;
//	GetClientRect(rect);  
		if(b=="P")((CPranchaVirtualDlg*)GetParent())->Imagem2(pDC, rectImagem);
		else ((CPranchaVirtualDlg*)((CPerfilDlg*)GetParent())->GetParent())->Imagem2(pDC, rectImagem);
		}
// Coloca a legenda
	CString texto;
	GetWindowText( texto );
	 	pDC->SetBkMode(TRANSPARENT);
	pDC->SetBkColor( m_corFundo );
	pDC->SetTextColor( GetSysColor( COLOR_WINDOWTEXT ) );
	pDC->DrawText( texto , rectTexto , DT_SINGLELINE | DT_CENTER | DT_VCENTER );
	
}

void CButton2::SetImagem( CString nome  )
{

	//*******************
	//	Testa a figura	*
	//*******************

	CFile arquivo;
	if (arquivo.Open(nome,CFile::modeRead)){
		m_arquivo=nome;
		m_aberto=true;
		arquivo.Close();
// Desenha a figura
		}
	else {
		m_aberto=false;
// Desenha o erro
		}
}
 
void CButton2::OnMouseMove(UINT nFlags, CPoint point) 
{
	//***************************************
	//	Evento enquanto o mouse se move		*
	//***************************************

	if (!m_movendo){
		TRACKMOUSEEVENT tme;
		tme.cbSize = sizeof(tme);
		tme.hwndTrack = m_hWnd;
		tme.dwFlags = TME_LEAVE|TME_HOVER;
		tme.dwHoverTime = 1;
		m_movendo = _TrackMouseEvent(&tme);
		}
	CButton::OnMouseMove(nFlags, point);
}

void CButton2::OnMouseHover(WPARAM wparam, LPARAM lparam) 
{

	//***********************
	//	Evento de Entrada	*
	//***********************

	if(m_cima==false){
// Colore de marelo
		SetCor(RGB(255,255,0));
		UpdateData();

// Pega o tempo atual
		char time[10];
		_strtime(time);
		CString tmp1=time;
		tmp1.Delete(0,6);
		int tmp2=atoi(tmp1);
		CString b;
		GetParent()->GetWindowText(b);
		b.Delete(1,b.GetLength()-1);
		tmp2+=((CPranchaVirtualDlg*)GetParent())->config.atraso;

// Arruma os segundos no minuto
		if(tmp2>=60)tmp2=tmp2-60;
		tmp1.Format("%d",tmp2);
		((CPranchaVirtualDlg*)GetParent())->config.tempo=atoi(tmp1);
// Seta o timer
		if(((CPranchaVirtualDlg*)GetParent())->config.autoclique==1)
			SetTimer(1,1000,0);
		UpdateData(FALSE);		
		Invalidate();
		}
		
	m_cima=TRUE;	
}


LRESULT CButton2::OnMouseLeave(WPARAM wparam, LPARAM lparam)
{

	//***********************
	//	Evento de Sada		*
	//***********************


	if(m_cima){
// Volta a cor do boto
		SetCor(GetSysColor(COLOR_BTNFACE));
		KillTimer(1);
		Invalidate();
		}
	m_movendo=false;
	m_cima   =false;

// Atualiza
	return 0;
} 
void CButton2::SetCor(COLORREF clrBackground)
{

	//***************************
	//	Seta a cor do boto		*
	//***************************
	
	m_corFundo = clrBackground;
	Invalidate();
}

void CButton2::OnTimer(UINT nIDEvent) 
{
	//***************
	//	AUTOCLIQUE	*
	//***************
	
	UpdateData();

	CString inicial,final,dois;
	CString b;

// Tempo inicial
	inicial.Format("%d",((CPranchaVirtualDlg*)GetParent())->config.tempo);
	
	char time[10];
	_strtime(time);
	final=time;
	final.Delete(0,6);

	int i=atoi(final);
	final.Format("%d",i);
	
	dois=inicial;
	dois+=" ";
	dois+=final;

// Se o Tempo FINAL for igual ao INICIAL mais o atraso
	if(inicial==final){
		SetCor(RGB(255,0,0));
		((CPranchaVirtualDlg*)GetParent())->OnButton();
		}
	UpdateData(FALSE);
	CButton::OnTimer(nIDEvent);
	
}

void CButton2::OnRButtonDown(UINT nFlags, CPoint point) 
{

	//***********************************
	//	Boto direito do mouse, MENU	*
	//***********************************


	CString temp;
	CString botao;
// Texto do boto
	GetWindowText(temp);

	CString temp2;
// Texto da janela
	GetWindowText(temp2);
	((CPranchaVirtualDlg*)GetParent())->GetWindowText(temp2);

// Abre se a janela ativa for a principal
	if(temp2!="Editar Smbolo" && temp2!="Novo Smbolo" && temp2!="Editar Usurio" && temp2!="Novo Usurio"){
		bool ponta;
		ClientToScreen(&point) ;
		HMENU hMenu = ::LoadMenu(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_MENU2)) ;

//Se o Usuario  o padro  padro desabilita apagar
		if(temp=="Padro"){
	//		EnableMenuItem(hMenu,ID_EDITAR,MF_GRAYED);
			EnableMenuItem(hMenu,ID_APAGAR,MF_GRAYED);
			}
		if(((CPranchaVirtualDlg*)GetParent())->imagem[2].nome==temp)
			ponta=true;
		else if(((CPranchaVirtualDlg*)GetParent())->imagem[53].nome==temp)
			ponta=true;
		else ponta=false;

// Se  boto do sistema, desabilita o apagar e o adicionar
		if(((CPranchaVirtualDlg*)GetParent())->m_grupoativo==0 ||
		   ((CPranchaVirtualDlg*)GetParent())->m_grupoativo==7 ||
			ponta==true ){
			EnableMenuItem(hMenu,ID_NOVO,MF_GRAYED);
			EnableMenuItem(hMenu,ID_APAGAR,MF_GRAYED);
			}

// Exibe o menu
		TrackPopupMenu(::GetSubMenu(hMenu, 0), MF_POPUP, point.x, point.y, 0, m_hWnd, NULL) ;
	}
}

void CButton2::MenuInserir() 
{
	//***************************************************
	// Inserir do menu pelo boto direito do Mouse		*
	//***************************************************

	CString temp;
// Texto do boto
	GetWindowText(temp);

// Envia o comando ao Menu da classe principal
	((CPranchaVirtualDlg*)GetParent())->Menu(temp,1);
}

void CButton2::MenuEditar() 
{

	//***********************************************
	// Editar do menu pelo boto direito do Mouse	*
	//***********************************************

	CString temp;
// Texto do boto
	GetWindowText(temp);

// Envia o comando ao Menu da classe principal
	((CPranchaVirtualDlg*)GetParent())->Menu(temp,2);
}

void CButton2::MenuApagar() 
{

	//***********************************************
	// Apagar do menu pelo boto direito do Mouse	*
	//***********************************************

	CString temp;
// Texto do boto
	GetWindowText(temp);

// Envia o comando ao Menu da classe principal
	((CPranchaVirtualDlg*)GetParent())->Menu(temp,3);
	
}

