/*
Prancha Livre de Comunicao
Copyright (C) 2005 Percy Nohama <percy@ppgia.pucpr.br>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// Perfil.cpp : implementation file
//

#include "stdafx.h"
#include "PranchaVirtual.h"
#include "PerfilDlg.h"
#include "PranchaVirtualDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPerfilDlg dialog


CPerfilDlg::CPerfilDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPerfilDlg::IDD, pParent)
{
	//***********************
	//*		Construtor		*
	//***********************

	// Inicializa as variveis
 
	m_confirmar=false;
	//{{AFX_DATA_INIT(CPerfilDlg)
	m_vedit = _T("");
	//}}AFX_DATA_INIT
}


void CPerfilDlg::DoDataExchange(CDataExchange* pDX)
{
	//************************************************************
	//	Associa o ID dos componentes grficos com a varivel	 *
	//************************************************************

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPerfilDlg)
	DDX_Control(pDX, IDC_EDIT2, m_cedit);
	DDX_Control(pDX, IDC_BUTTON2, m_b2);
	DDX_Control(pDX, IDC_BUTTON1, m_b1);
	DDX_Text(pDX, IDC_EDIT2, m_vedit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPerfilDlg, CDialog)
	//************************************************************
	//*	Associa o ID dos componentes grficos com a funo		 *
	//************************************************************

	//{{AFX_MSG_MAP(CPerfilDlg)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_BUTTON1, OnAbrir)
	ON_BN_CLICKED(IDC_BUTTON2, OnConfirmar)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPerfilDlg message handlers
//	

void CPerfilDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	//********************************************
	//*	Evento de inicializao da janela		 *
	//********************************************

	CDialog::OnShowWindow(bShow, nStatus);
	UpdateData();
	m_nome=m_vedit;

// Se o usurio padro, desabilita a caixa de editar
	if(m_nome=="Padro"){
		m_cedit.EnableWindow(FALSE);
		}

// Adiciona o Ttulo  janela e o texto do boto
	if(m_nome.GetLength()>0){
		if(((CPranchaVirtualDlg*)GetParent())->m_grupoativo==8)
			SetWindowText("Editar Usurio");
		else	
			SetWindowText("Editar Smbolo");
		m_b2.SetWindowText("Alterar");
		}
	else {
		if(((CPranchaVirtualDlg*)GetParent())->m_grupoativo==8)
			SetWindowText("Novo Usurio");
		else	
			SetWindowText("Novo Smbolo");
		m_b2.SetWindowText("Incluir");
		}
	 m_repetido=false;

	
}


void CPerfilDlg::OnAbrir() 
{
	//********************************************
	//*	Abre a janela que adiciona a imagem		 *
	//********************************************

	CFileDialog fileDlg(TRUE, NULL, NULL, OFN_ALLOWMULTISELECT | OFN_HIDEREADONLY,"Imagens (*.bmp, *.gif, *.jpeg)|*.bmp;*.gif;*.jpg||",this);
	CString temp=((CPranchaVirtualDlg*)GetParent())->m_desktop;
	temp+="\\Imagens da Prancha";
	fileDlg.m_ofn.lpstrInitialDir=temp;
// Abre a janela e coloca a imagem no boto
	if ( fileDlg.DoModal() == IDOK){
		m_b1.SetImagem(fileDlg.GetPathName());
		
		}
}

void CPerfilDlg::OnConfirmar() 
{
	//****************************************************
	//*	Valida a imagem e a legenda e fechaa a janela	 *
	//****************************************************
	UpdateData();	
	m_repetido=false;
	m_confirmar=true;
	CString t;
	GetWindowText(t);
	int i=1;
	if(t.Find("Smbolo",0)>0 ){
// Erro: legenda vazia
		if(m_vedit.GetLength()==0){
			MessageBox("A legenda no pode ser vazia.","ERRO",MB_ICONERROR);
			m_confirmar=false;
			m_repetido=true;
			}
// Erro: imagem vazia
		else if(m_b1.m_arquivo.GetLength()==0){
			MessageBox("A imagem no pode ser vazia.","ERRO",MB_ICONERROR);
			m_confirmar=false;
			m_repetido=true;
			}
		else{
			i=1;
// Procura por  legendas repetidas
			for(int j=1;j<=6;j++){
				i=1;
				do{
					if(m_vedit==((CPranchaVirtualDlg*)GetParent())->grupo[j][i].nome && m_vedit!=m_nome){
						m_confirmar=false;
						m_repetido=true;
						}
					i++;
					}while(((CPranchaVirtualDlg*)GetParent())->grupo[j][i].nome.GetLength()>0);
				}
			if(m_repetido==true ){
				MessageBox("A legenda no pode ser repetida.","ERRO",MB_ICONERROR);
				m_confirmar=false;
				m_vedit=m_nome;
				}
			}

		if( m_repetido==false){
// Fecha a janela
			CWnd *a;
			a=CWnd::GetActiveWindow();
			a->SendMessage(WM_CLOSE);
			}
			
		}
	else{//novo usuario
	
		int t=1;
// Procura por usurios repetidos
		do{
			if(((CPranchaVirtualDlg*)GetParent())->usuario[t].nome==m_vedit)
				m_repetido=true;
			t++;
			}while(((CPranchaVirtualDlg*)GetParent())->usuario[t].nome.GetLength()>0);
// Verifica erros
		if(m_repetido==true && m_vedit!=m_nome){
			MessageBox("O Usurio no pode ser repetido.","ERRO",MB_ICONERROR);
			m_confirmar=false;
			}
		else if(m_b1.m_arquivo.GetLength()==0){
			MessageBox("A imagem no pode ser vazia.","ERRO",MB_ICONERROR);
			m_confirmar=false;
			}
		else if(m_vedit.GetLength()==0){
			MessageBox("A legenda no pode ser vazia.","ERRO",MB_ICONERROR);
			m_confirmar=false;
			}
		else if(m_vedit.Find("*",0)>=0){
			MessageBox("A legenda no pode conter o caractere '*'.","ERRO",MB_ICONERROR);
			m_confirmar=false;
			}
		else{
// Fecha a janela
			CWnd *a;
			a=CWnd::GetActiveWindow();
			a->SendMessage(WM_CLOSE);
			}
		}
	
}
 
