/*
Prancha Livre de Comunicao
Copyright (C) 2005 Percy Nohama <percy@ppgia.pucpr.br>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// PranchaVirtualDlg.h : header file
//

#if !defined(AFX_PRANCHAVIRTUALDLG_H__87848949_2D05_4FF2_B61A_F0052F230AC0__INCLUDED_)
#define AFX_PRANCHAVIRTUALDLG_H__87848949_2D05_4FF2_B61A_F0052F230AC0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CPranchaVirtualDlg dialog
#include "Button2.h"
#include "Static2.h"


//////////////////////////////////////////////////////////////////////////////


class CPranchaVirtualDlg : public CDialog
{
// Construction
public:
	int m_resx;		// Resoluo X
	int m_resy;		// Resoluo Y
	CString m_tipo;	// Tipo da imagem de fundo
	int m_posicao;	// Posio na frase
	int m_pagina;		// Parte a exibir
	int m_grupoativo;	// Janela aberta
	int m_vver;		// Varredura, posio vertical
	int m_vpos;		// Varredura, estado em vertical ou horizontal
	int m_vhor;		// Varredra, posiorizontal
	CString m_diretorio;// diretorio do programa
	CString m_desktop;// Diretrio do desktop
	struct Tela{	// Posio da tela
		int esq;	// Esquerda
		int topo;	// Cima
		int alt;	// Altura
		int lar;	// Largura
		}tela;
	
	struct Config{			// Armazena os dados da Configuraes
		int usrcont;		// Contador de usurios
		CString interfac;	// Janela ativa
		bool legenda;		// Seta a legenda
		bool varredura;		// Varredura
		bool autoclique;	// Autoclique
		COLORREF cor;		// false de fundo
		CString fundo;		// Papel de parede
		CString tipo;		// Tipo do papel de parede
		int atraso;			// Atraso do autoclique
		int tempo;			// Controlde do tempo
		bool masculino;			// Homem ou mulher
		bool som;			// Habilita o som a cada smbolo
		}config;

	struct Predicao{		// Armazena os dados da predio
		CString tudo;		// Soma de todos os dados em texto
		CString grupo;
		CString codigo;
		CString nome;		// Legenda
		CString caminho;	// Arquivo em texto
		int contador;
		bool achou;
		}pre[7];

	struct Grupo{		// Armazena os dados das imagens dos botes
		CString nome;
		CString caminho;// Arquivo em texto
		int contador;
		int codigo;
		CString historico;
		}grupo[7][500],usuario[100], imagem[100] ;
	//grupo[no. do grupo][no. da figura]
	
	bool sintativo; // estado do sintetizador

	CPranchaVirtualDlg(CWnd* pParent = NULL);	// standard constructor
	void Imagem(CDC *pDC, CString m_arquivo, CRect rectImagem);		// Abre imagem externa
	void Imagem2(CDC *pDC,CRect rect);								// Abre imagem Bitmap
	void Limpar();				// Limpa a varivel arquivo de cada boto
	void Menu(CString nome, int posicao);	// Menu do boto
	void MenuInserir();			// Menu da janela
	void OnButton();			// Boto de origem, envia a funo de afalsedo com a interface
	void OnButPrincipal();		// Boto pressionado na janela principal
	void OnButPerfil();			// Boto pressionado na perfil perfil
	void OnButOpcao();			// Boto pressionado na opo principal
	void OnButGrupo();			// Boto pressionado na grupo principal
	void OnButPredicao(int pos);// Boto de predio pressionado
	bool SintetizadorAbrir(CString frase);	// Inicia o Sintetizaodr
	void SintetizadorFechar();							// Fecha o sintetizador

private:
 	void OnFalar();				// Ativa o sintetizador de voz
 	void OnLegenda();			// Retira ou no a legenda
	
	void IniAbrir();			// Abre as configuraes do aplicativo
	void IniFechar();			// Salva a lista no arquivo config.ini
	
	void InterConf();			// Interface das Configuraes
	void InterPrincipal();		// Interface das Principal
	void InterPerfil();			// Interface do Perfil do Usurio
	void InterOpcao();			// Interface das Opes
 	void InterGrupo();			// Atualiza a tela com o grupo

	void Ocultar();				// Esconde os botes vazios
	void OnImprimir();			// Envia para a impressora o texto da frase
  	void Predicao(int posicao);	// Realiza a predio da imagem
	void Resolucao(int lar,int alt);	// Realiza a predio da imagem

	void UsuConf(CString usuario);	// Configurao de cada pasta de usurio 

	// Dialog Data
	//{{AFX_DATA(CPranchaVirtualDlg)
	enum { IDD = IDD_PRANCHAVIRTUAL_DIALOG };
	CStatic		m_area;	// rea em branco onde ser composta a frase
	CStatic2	m_bit6;	// 6a imagem na frase
	CStatic2	m_bit5;	// 5a imagem na frase
	CStatic2	m_bit4;	// 4a imagem na frase
	CStatic2	m_bit3;	// 3a imagem na frase
	CStatic2	m_bit2;	// 2a imagem na frase
	CStatic2	m_bit1;	// 1a imagem na frase
	CButton2	m_b18;	// Botes na janela 1 a 18
	CButton2	m_b17;
	CButton2	m_b16;
	CButton2	m_b15;
	CButton2	m_b14;
	CButton2	m_b13;
	CButton2	m_b12;
	CButton2	m_b11;
	CButton2	m_b10;
	CButton2	m_b9;
	CButton2	m_b8;
	CButton2	m_b7;
	CButton2	m_b6;
	CButton2	m_b5;
	CButton2	m_b4;
	CButton2	m_b3;
	CButton2	m_b2;
	CButton2	m_b1;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPranchaVirtualDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);		// Monitora o teclado
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CPranchaVirtualDlg)
	virtual BOOL OnInitDialog();							// Ao iniciar o aplicativo
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);					// Ao desenhar a janela
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);	// Clique da direita
	afx_msg void OnTimer(UINT nIDEvent);					// Timer da Varredura
	afx_msg void OnDestroy();								// Sair do programa
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PRANCHAVIRTUALDLG_H__87848949_2D05_4FF2_B61A_F0052F230AC0__INCLUDED_)
